| Haskell Hierarchical Libraries (mtl package) | Source code | Contents | Index

Control.Monad.Reader

Portability | non-portable (multi-param classes, functional dependencies)
Stability | experimental
Maintainer | libraries@haskell.org

Description
Declaration of the MonadReader class Inspired by the paper Functional Programming with Overloading and Higher-Order Polymorphism, Mark P Jones (http://www.cse.ogi.edu/~mpj/) Advanced School of Functional Programming, 1995.
Documentation
module Control.Monad.Reader.Class
newtype Reader r a

Constructors

Reader |

runReader :: (r -> a) |

Instances

MonadReader r (Reader r)
Functor (Reader r)
Monad (Reader r)
MonadFix (Reader r)

mapReader :: (a -> b) -> Reader r a -> Reader r b
withReader :: (r' -> r) -> Reader r a -> Reader r' a
newtype ReaderT r m a

Constructors

ReaderT |

runReaderT :: (r -> m a) |

Instances

MonadError e m => MonadError e (ReaderT r m)
Monad m => MonadReader r (ReaderT r m)
MonadState s m => MonadState s (ReaderT r m)
MonadWriter w m => MonadWriter w (ReaderT r m)
MonadTrans (ReaderT r)
Monad m => Functor (ReaderT r m)
Monad m => Monad (ReaderT r m)
MonadCont m => MonadCont (ReaderT r m)
MonadFix m => MonadFix (ReaderT r m)
MonadIO m => MonadIO (ReaderT r m)
MonadPlus m => MonadPlus (ReaderT r m)

mapReaderT :: (m a -> n b) -> ReaderT w m a -> ReaderT w n b
withReaderT :: (r' -> r) -> ReaderT r m a -> ReaderT r' m a
module Control.Monad
module Control.Monad.Fix
module Control.Monad.Trans
Produced by Haddock version 0.8